local e=require"luci.cbi.datatypes"
local h="/etc/mosdns/rule/whitelist.txt"
local r="/etc/mosdns/rule/blocklist.txt"
local i="/etc/mosdns/rule/greylist.txt"
local n="/etc/mosdns/rule/hosts.txt"
local e="/etc/mosdns/rule/redirect.txt"
local a="/etc/mosdns/rule/local-ptr.txt"
local t="/etc/mosdns/rule/ddnslist.txt"
m=Map("mosdns")
s=m:section(TypedSection,"mosdns",translate("Rule Settings"))
s.anonymous=true
s:tab("white_list",translate("White Lists"))
s:tab("block_list",translate("Block Lists"))
s:tab("grey_list",translate("Grey Lists"))
s:tab("ddns_list",translate("DDNS Lists"))
s:tab("hosts_list",translate("Hosts"))
s:tab("redirect_list",translate("Redirect"))
s:tab("local_ptr_list",translate("Block PTR"))
o=s:taboption("white_list",TextValue,"whitelist","","<font color='red'>"..translate("These domain names allow DNS resolution with the highest priority. Please input the domain names of websites, every line can input only one website domain. For example: hm.baidu.com.").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(h)or""end
o.write=function(t,t,e)nixio.fs.writefile(h,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(h,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("block_list",TextValue,"blocklist","","<font color='red'>"..translate("These domains are blocked from DNS resolution. Please input the domain names of websites, every line can input only one website domain. For example: baidu.com.").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(r)or""end
o.write=function(t,t,e)nixio.fs.writefile(r,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(r,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("grey_list",TextValue,"greylist","","<font color='red'>"..translate("These domains are always resolved using remote DNS. Please input the domain names of websites, every line can input only one website domain. For example: google.com.").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(i)or""end
o.write=function(t,t,e)nixio.fs.writefile(i,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(i,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("ddns_list",TextValue,"ddns","","<font color='red'>"..translate("These domains are always resolved using local DNS. And force TTL 5 seconds, DNS resolution results will not enter the cache. For example: myddns.example.com.").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(t)or""end
o.write=function(a,a,e)nixio.fs.writefile(t,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(t,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("hosts_list",TextValue,"hosts","","<font color='red'>"..translate("Hosts For example: baidu.com 10.0.0.1").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(n)or""end
o.write=function(t,t,e)nixio.fs.writefile(n,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(n,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("redirect_list",TextValue,"redirect","","<font color='red'>"..translate("The domain name to redirect the request to. Requests domain A, but returns records for domain B. example: a.com b.com").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(t,t)return nixio.fs.readfile(e)or""end
o.write=function(a,a,t)nixio.fs.writefile(e,t:gsub("\r\n","\n"))end
o.remove=function(t,t,t)nixio.fs.writefile(e,"")end
o.validate=function(t,e)
return e
end
o=s:taboption("local_ptr_list",TextValue,"local_ptr","","<font color='red'>"..translate("These domains are blocked from PTR requests").."</font>".."<font color='#00bd3e'>"..translate("<br>The list of rules only apply to 'Default Config' profiles.").."</font>")
o.rows=15
o.wrap="off"
o.cfgvalue=function(e,e)return nixio.fs.readfile(a)or""end
o.write=function(t,t,e)nixio.fs.writefile(a,e:gsub("\r\n","\n"))end
o.remove=function(e,e,e)nixio.fs.writefile(a,"")end
o.validate=function(t,e)
return e
end
local e=luci.http.formvalue("cbi.apply")
if e then
luci.sys.exec("/etc/init.d/mosdns reload")
end
return m
